#!/bin/bash

#echo on


# look for filename $1 in directory $2 and all its sub-directories
finddoubleof()
{
  sourcefile=$1   # 1st param
  searchdir=$2   # 2nd param
#  echo finddoubleof param1=${sourcefile}   param2=${searchdir}

  if test -d "${sourcefile}"		# is our file a directory ?
  then
#    echo DIR "${sourcefile}"
    finddoubleindirectory "${sourcefile}"
  else					# file is not a directory
 #    echo FILE "${sourcefile}"
    for destfile in "${searchdir}"/*
    do
  #     echo test "${sourcefile}" avec "${destfile}"
      if test -d "${destfile}"		# is our file a directory ?
      then
#        echo look for "${sourcefile}" in DIR "${destfile}"
        finddoubleof "${sourcefile}" "${destfile}"
      else				# file is not a directory
#        echo compare "${sourcefile}" and "${destfile}"
	if test "${sourcefile}" != "${destfile}"	# don't compare the file with itself
	then
          cmp -s "${sourcefile}" "${destfile}"
  	  result=$?		 # $? is result code of last command (previous line)
          if [ ${result} = 0 ]
	  then
	      echo SAME FILES "${sourcefile}" AND  "${destfile}"
	   fi
	fi
      fi
    done
  fi
}
#end of finddoubleof


# find same files in directory $1
finddoubleindirectory()
{
  for filetofinddouble in ${1}/*
  do
      finddoubleof "${filetofinddouble}" "${currentpwd}";
  done
}
# end of finddoubleindirectory()


# main()

# if finddouble.sh called without parameters, we look for double from the current directory
if test ${1}
then
  currentpwd=${1}
else
  currentpwd=`pwd`
fi

finddoubleindirectory ${currentpwd}
#end of main()

exit 0
